"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Jimp = require("jimp");
var path = require("path");
var index_1 = require("../src/index");
var combineAllPossible_1 = require("../src/utilities/combineAllPossible");
beforeAll(function () {
    jest.setTimeout(5000);
});
describe('combineAllPossible', function () {
    test('should be able to combine multiple results into one complete', function () {
        var result = combineAllPossible_1.combineAllPossible('?123456', '012345?');
        expect(result).toBe('0123456');
    });
});
describe('extract barcode from local files', function () {
    test('should detect barcode codabar', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/codabar.jpg'),
                        barcode: index_1.BARCODE_DECODERS.codabar
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('A40156C');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode codabar', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/codabar.jpg'),
                        barcode: index_1.BARCODE_DECODERS.codabar,
                        options: {
                            singlePass: true
                        }
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('A40156C');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 2 of 5 standard', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-2of5.jpg'),
                        barcode: 'code-2of5'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('12345670');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 2 of 5 interleaved', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-2of5-interleaved.jpg'),
                        barcode: 'code-2of5',
                        barcodeType: 'interleaved'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('12345670');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 39', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-39.jpg'),
                        barcode: 'code-39'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('10023');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 93', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-93.jpg'),
                        barcode: 'code-93'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('123ABC');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 128', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-128.jpg'),
                        barcode: 'code-128'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('ABC-abc-1234');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode EAN-8', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/ean-8.jpg'),
                        barcode: 'ean-8'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('73127727');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode EAN-13', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/ean-13.jpg'),
                        barcode: 'ean-13'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('901234123457');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 128 without padding white bars', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-128-no-padding.jpg'),
                        barcode: 'code-128'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('12ab#!');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 128 with multiple zeros', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-128-000.jpg'),
                        barcode: 'code-128'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('79619647103200000134407005');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 128 with default start Code B', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/L89HE1806005080432.gif'),
                        barcode: 'code-128'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('L89HE1806005080432');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 93 without padding white bars', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-93-no-padding.jpg'),
                        barcode: 'code-93'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('WIKIPEDIA');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 93 with bitmap data', function () { return __awaiter(void 0, void 0, void 0, function () {
        var image, _a, data, width, height, result;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, Jimp.read('./test/sample-images/code-93-no-padding.jpg')];
                case 1:
                    image = _b.sent();
                    _a = image.bitmap, data = _a.data, width = _a.width, height = _a.height;
                    return [4 /*yield*/, index_1.javascriptBarcodeReader({
                            image: {
                                data: Uint8ClampedArray.from(data),
                                width: width,
                                height: height
                            },
                            barcode: 'code-93'
                        })];
                case 2:
                    result = _b.sent();
                    expect(result).toBe('WIKIPEDIA');
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('extract barcode after applying adaptive threhsold', function () {
    test('should detect barcode codabar', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/codabar.jpg'),
                        barcode: 'codabar',
                        options: {
                            useAdaptiveThreshold: true
                        }
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('A40156C');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 2 of 5', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-2of5.jpg'),
                        barcode: 'code-2of5',
                        options: {
                            useAdaptiveThreshold: true
                        }
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('12345670');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should detect barcode 2 of 5 interleaved', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: path.resolve('./test/sample-images/code-2of5-interleaved.jpg'),
                        barcode: 'code-2of5',
                        barcodeType: 'interleaved',
                        options: {
                            useAdaptiveThreshold: true
                        }
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('12345670');
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('extract barcode from remote URL', function () {
    test('should detect barcode 93 from remote url', function () { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.javascriptBarcodeReader({
                        image: 'https://upload.wikimedia.org/wikipedia/en/a/a9/Code_93_wikipedia.png',
                        barcode: 'code-93'
                    })];
                case 1:
                    result = _a.sent();
                    expect(result).toBe('WIKIPEDIA');
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('Fails', function () {
    test('throws when no barcode specified', function () { return __awaiter(void 0, void 0, void 0, function () {
        var err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, index_1.javascriptBarcodeReader({
                            image: 'https://upload.wikimedia.org/wikipedia/en/a/a9/Code_93_wikipedia.png',
                            barcode: 'oallal'
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _a.sent();
                    expect(err_1).toBeDefined();
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    test('throws when invalid barcode specified', function () { return __awaiter(void 0, void 0, void 0, function () {
        var err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, index_1.javascriptBarcodeReader({
                            image: './test/sample-images/empty.jpg',
                            barcode: 'none'
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    err_2 = _a.sent();
                    expect(err_2).toBeDefined();
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    test('throws when no barcode found', function () { return __awaiter(void 0, void 0, void 0, function () {
        var err_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, index_1.javascriptBarcodeReader({
                            image: './test/sample-images/empty.jpg',
                            barcode: 'code-93'
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    err_3 = _a.sent();
                    expect(err_3).toBeDefined();
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=index.test.js.map